\documentclass[a4paper]{article}
\usepackage[english]{babel}
\usepackage[T1]{fontenc}
\usepackage[a4paper, top=0.75cm, bottom=0.75cm, left=2cm, right=2cm]{geometry}
\usepackage{listings}
\usepackage{inconsolata}
\pagenumbering{gobble}
\lstset{frame=single, showstringspaces=false, columns=fixed, basicstyle={\ttfamily}, commentstyle={\it}, numbers=left, tabsize=4}
\begin{document}
\lstset{language={[ANSI]C}}
\lstset{literate={float.}{float.}6}
\lstset{morekeywords={size_t, ssize_t, bool, sem_t, Task, TaskStream, Worker, Swarm}}
\lstset{moredelim=[s][\it]{__}{__}}
\lstset{moredelim=[s][\it]{((}{))}}
\lstset{title=Contents of \texttt{src/terminator.h}}
\title{An auxiliary library for atomic I/O and error reporting.}
\date{\vspace{-5ex}}
\author{\vspace{-5ex}}
\maketitle
\centering
\begin{lstlisting}
#ifndef _TERMINATOR_H
#define _TERMINATOR_H

void atomize(void);

void announce(const char *, ...)
    __attribute__ (( nonnull ))
    __attribute__ (( format (printf, 1, 2) ));

void terminate(int, const char *, ...)
    __attribute__ (( noreturn ))
    __attribute__ (( nonnull ))
    __attribute__ (( format (printf, 2, 3) ));

#endif
\end{lstlisting}
\lstset{title=Contents of \texttt{src/terminator.c}}
\begin{lstlisting}
#include <errno.h>
#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <semaphore.h>
#include <signal.h>
#include <sys/types.h>

#include "terminator.h"
#include "forkshare.h"

sem_t *term_sem = NULL;

void atomize(void)
{
    if (term_sem)
        return;
    
    // Make a semaphore for I/O operations.
    term_sem = forkshare(sizeof(*term_sem));
    if (!term_sem)
        terminate(errno, "Unable to allocate memory for semaphore.\n");
        
    if (sem_init(term_sem, 1, 1))
        terminate(errno, "Unable to initialize the semaphore.\n");
}

\end{lstlisting}
\newpage
\begin{lstlisting}[firstnumber=last]
void announce(const char *fmt, ...)
{
    // If term_sem is initialized, use semaphores for atomic I/O.
    if (term_sem)
        while (sem_wait(term_sem))
            if (errno != EINTR)
                exit(-1);

    // Print the formatted message.
    va_list args;
    va_start(args, fmt);
    vfprintf(stdout, fmt, args);
    va_end(args);
    fflush(stdout);

    // If term_sem is initialized, use semaphores for atomic I/O.
    if (term_sem)
        sem_post(term_sem);
}

void terminate(int code, const char *fmt, ...)
{
    // If term_sem is initialized, use semaphores for atomic I/O.
    if (term_sem)
        while (sem_wait(term_sem))
            if (errno != EINTR)
                exit(-1);

    // Print the formatted message.
    va_list args;
    va_start(args, fmt);
    vfprintf(stderr, fmt, args);
    va_end(args);

    // Print the error message, if any.
    if (code)
        fprintf(stderr, "Error: %s \n", strerror(code));
    fflush(stderr);

    // If term_sem is initialized, use semaphores for atomic I/O.
    if (term_sem)
        sem_post(term_sem);

    kill(0, SIGINT);
    exit(-errno);
}
\end{lstlisting}
\end{document}
